Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageAccumulate Class Reference

`#include <vtkImageAccumulate.h>`

Inheritance diagram for vtkImageAccumulate:

[legend]
Collaboration diagram for vtkImageAccumulate:

[legend]
List of all members.

## Detailed Description

Generalized histograms up to 4 dimensions.

Date:
  2002/12/11 14:26:22

Revision:
  1.32

vtkImageAccumulate - This filter divides component space into discrete bins. It then counts the number of pixels associated with each bin. The output is this "scatter plot" (histogram values for 1D). The dimensionality of the output depends on how many components the input pixels have. Input pixels with one component generate a 1D histogram. This filter can only handle images with 1 to 3 scalar components. The input can be any type, but the output is always int. Some statistics are computed on the pixel values at the same time. The SetStencilFunction, SetClippingExtents and ReverseStencil functions allow the statistics to be computed on an arbitrary portion of the input data. See the documentation for vtkImageStencil for more information.

Created by:
  - Law, Charles

CVS contributions (if > 5%):
  - Law, Charles (42%)
  - Starreveld, Yves (16%)
  - Gobbi, David (13%)
  - Lorensen, Bill (10%)
  - Schroeder, Will (6%)
  - Martin, Ken (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Imaging/vtkImageAccumulate.cxx)`
  - .`h` (`/Imaging/vtkImageAccumulate.h)`

Examples:
  vtkImageAccumulate (Examples)

Tests:
  vtkImageAccumulate (Tests)

Definition at line 65 of file vtkImageAccumulate.h.

## Public Types
typedef vtkImageToImageFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetComponentSpacing (float, float, float)
virtual void | SetComponentSpacing (float[3])
virtual float * | GetComponentSpacing ()
virtual void | GetComponentSpacing (float &, float &, float &)
virtual void | GetComponentSpacing (float[3])
virtual void | SetComponentOrigin (float, float, float)
virtual void | SetComponentOrigin (float[3])
virtual float * | GetComponentOrigin ()
virtual void | GetComponentOrigin (float &, float &, float &)
virtual void | GetComponentOrigin (float[3])
void | SetComponentExtent (int extent[6])
void | SetComponentExtent (int minX, int maxX, int minY, int maxY, int minZ, int maxZ)
void | GetComponentExtent (int extent[6])
int * | GetComponentExtent ()
void | SetStencil (vtkImageStencilData *stencil)
vtkImageStencilData * | GetStencil ()
virtual void | SetReverseStencil (int)
virtual void | ReverseStencilOn ()
virtual void | ReverseStencilOff ()
virtual int | GetReverseStencil ()
virtual double * | GetMin ()
virtual void | GetMin (double &, double &, double &)
virtual void | GetMin (double[3])
virtual double * | GetMax ()
virtual void | GetMax (double &, double &, double &)
virtual void | GetMax (double[3])
virtual double * | GetMean ()
virtual void | GetMean (double &, double &, double &)
virtual void | GetMean (double[3])
virtual double * | GetStandardDeviation ()
virtual void | GetStandardDeviation (double &, double &, double &)
virtual void | GetStandardDeviation (double[3])
virtual long int | GetVoxelCount ()
## Static Public Methods
vtkImageAccumulate * | New ()
int | IsTypeOf (const char *type)
vtkImageAccumulate * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImageAccumulate ()
| ~vtkImageAccumulate ()
void | ExecuteInformation (vtkImageData *input, vtkImageData *output)
void | ComputeInputUpdateExtent (int inExt[6], int outExt[6])
void | ExecuteInformation ()
void | ExecuteData (vtkDataObject *out)
## Protected Attributes
float | ComponentSpacing [3]
float | ComponentOrigin [3]
int | ComponentExtent [6]
double | Min [3]
double | Max [3]
double | Mean [3]
double | StandardDeviation [3]
long int | VoxelCount
int | ReverseStencil

## Member Typedef Documentation

typedef vtkImageToImageFilter vtkImageAccumulate::Superclass

| Reimplemented from vtkImageToImageFilter. Definition at line 69 of file vtkImageAccumulate.h.

## Constructor & Destructor Documentation

vtkImageAccumulate::vtkImageAccumulate | ( |  | ) | `[protected]`

vtkImageAccumulate::~vtkImageAccumulate | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageAccumulate* vtkImageAccumulate::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkImageAccumulate::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkImageToImageFilter.

int vtkImageAccumulate::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageToImageFilter.

virtual int vtkImageAccumulate::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkImageToImageFilter.

vtkImageAccumulate* vtkImageAccumulate::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkImageToImageFilter.

void vtkImageAccumulate::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkImageToImageFilter.

virtual void vtkImageAccumulate::SetComponentSpacing | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get - The component spacing is the dimension of each bin. This ends up being the spacing of the output "image". If the number of input scalar components are less than three, then some of these spacing values are ignored. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this spacing should be set to 100, 0, 0

virtual void vtkImageAccumulate::SetComponentSpacing | ( | float | [3] | ) | `[virtual]`

| Set/Get - The component spacing is the dimension of each bin. This ends up being the spacing of the output "image". If the number of input scalar components are less than three, then some of these spacing values are ignored. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this spacing should be set to 100, 0, 0

virtual float* vtkImageAccumulate::GetComponentSpacing | ( |  | ) | `[virtual]`

| Set/Get - The component spacing is the dimension of each bin. This ends up being the spacing of the output "image". If the number of input scalar components are less than three, then some of these spacing values are ignored. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this spacing should be set to 100, 0, 0

virtual void vtkImageAccumulate::GetComponentSpacing | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set/Get - The component spacing is the dimension of each bin. This ends up being the spacing of the output "image". If the number of input scalar components are less than three, then some of these spacing values are ignored. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this spacing should be set to 100, 0, 0

virtual void vtkImageAccumulate::GetComponentSpacing | ( | float | [3] | ) | `[virtual]`

| Set/Get - The component spacing is the dimension of each bin. This ends up being the spacing of the output "image". If the number of input scalar components are less than three, then some of these spacing values are ignored. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this spacing should be set to 100, 0, 0

virtual void vtkImageAccumulate::SetComponentOrigin | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set/Get - The component origin is the location of bin (0, 0, 0). Note that if the Component extent does not include the value (0,0,0), then this origin bin will not actually be in the output. The origin of the output ends up being the same as the componenet origin. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this origin should be set to 1000, 0, 0

virtual void vtkImageAccumulate::SetComponentOrigin | ( | float | [3] | ) | `[virtual]`

| Set/Get - The component origin is the location of bin (0, 0, 0). Note that if the Component extent does not include the value (0,0,0), then this origin bin will not actually be in the output. The origin of the output ends up being the same as the componenet origin. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this origin should be set to 1000, 0, 0

virtual float* vtkImageAccumulate::GetComponentOrigin | ( |  | ) | `[virtual]`

| Set/Get - The component origin is the location of bin (0, 0, 0). Note that if the Component extent does not include the value (0,0,0), then this origin bin will not actually be in the output. The origin of the output ends up being the same as the componenet origin. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this origin should be set to 1000, 0, 0

virtual void vtkImageAccumulate::GetComponentOrigin | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set/Get - The component origin is the location of bin (0, 0, 0). Note that if the Component extent does not include the value (0,0,0), then this origin bin will not actually be in the output. The origin of the output ends up being the same as the componenet origin. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this origin should be set to 1000, 0, 0

virtual void vtkImageAccumulate::GetComponentOrigin | ( | float | [3] | ) | `[virtual]`

| Set/Get - The component origin is the location of bin (0, 0, 0). Note that if the Component extent does not include the value (0,0,0), then this origin bin will not actually be in the output. The origin of the output ends up being the same as the componenet origin. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this origin should be set to 1000, 0, 0

void vtkImageAccumulate::SetComponentExtent | ( | int | extent[6] | ) |

| Set/Get - The component extent sets the number/extent of the bins. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this extent should be set to 0, 9, 0, 0, 0, 0. The extent specifies inclusive min/max values. This implies the the top extent should be set to the number of bins - 1.

void vtkImageAccumulate::SetComponentExtent | ( | int | minX,
|  | int | maxX,
|  | int | minY,
|  | int | maxY,
|  | int | minZ,
|  | int | maxZ
| ) |

| Set/Get - The component extent sets the number/extent of the bins. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this extent should be set to 0, 9, 0, 0, 0, 0. The extent specifies inclusive min/max values. This implies the the top extent should be set to the number of bins - 1.

void vtkImageAccumulate::GetComponentExtent | ( | int | extent[6] | ) |

| Set/Get - The component extent sets the number/extent of the bins. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this extent should be set to 0, 9, 0, 0, 0, 0. The extent specifies inclusive min/max values. This implies the the top extent should be set to the number of bins - 1.

int* vtkImageAccumulate::GetComponentExtent | ( |  | ) | `[inline]`

| Set/Get - The component extent sets the number/extent of the bins. For a 1D histogram with 10 bins spanning the values 1000 to 2000, this extent should be set to 0, 9, 0, 0, 0, 0. The extent specifies inclusive min/max values. This implies the the top extent should be set to the number of bins - 1. Definition at line 103 of file vtkImageAccumulate.h.

void vtkImageAccumulate::SetStencil | ( | vtkImageStencilData * | stencil | ) |

| Use a stencil to specify which voxels to accumulate.

vtkImageStencilData* vtkImageAccumulate::GetStencil | ( |  | ) |

| Use a stencil to specify which voxels to accumulate.

virtual void vtkImageAccumulate::SetReverseStencil | ( | int |  | ) | `[virtual]`

| Reverse the stencil.

virtual void vtkImageAccumulate::ReverseStencilOn | ( |  | ) | `[virtual]`

| Reverse the stencil.

virtual void vtkImageAccumulate::ReverseStencilOff | ( |  | ) | `[virtual]`

| Reverse the stencil.

virtual int vtkImageAccumulate::GetReverseStencil | ( |  | ) | `[virtual]`

| Reverse the stencil.

virtual double* vtkImageAccumulate::GetMin | ( |  | ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMin | ( | double & | ,
|  | double & | ,
|  | double & |
| ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMin | ( | double | [3] | ) | `[virtual]`

| Get the statistics information for the data.

virtual double* vtkImageAccumulate::GetMax | ( |  | ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMax | ( | double & | ,
|  | double & | ,
|  | double & |
| ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMax | ( | double | [3] | ) | `[virtual]`

| Get the statistics information for the data.

virtual double* vtkImageAccumulate::GetMean | ( |  | ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMean | ( | double & | ,
|  | double & | ,
|  | double & |
| ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetMean | ( | double | [3] | ) | `[virtual]`

| Get the statistics information for the data.

virtual double* vtkImageAccumulate::GetStandardDeviation | ( |  | ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetStandardDeviation | ( | double & | ,
|  | double & | ,
|  | double & |
| ) | `[virtual]`

| Get the statistics information for the data.

virtual void vtkImageAccumulate::GetStandardDeviation | ( | double | [3] | ) | `[virtual]`

| Get the statistics information for the data.

virtual long int vtkImageAccumulate::GetVoxelCount | ( |  | ) | `[virtual]`

| Get the statistics information for the data.

void vtkImageAccumulate::ExecuteInformation | ( | vtkImageData * | input,
|  | vtkImageData * | output
| ) | `[protected, virtual]`

| Reimplemented from vtkImageToImageFilter.

void vtkImageAccumulate::ComputeInputUpdateExtent | ( | int | inExt[6],
|  | int | outExt[6]
| ) | `[protected, virtual]`

| Reimplemented from vtkImageToImageFilter.

void vtkImageAccumulate::ExecuteInformation | ( |  | ) | `[inline, protected, virtual]`

| Reimplemented from vtkImageToImageFilter. Definition at line 140 of file vtkImageAccumulate.h. References vtkImageToImageFilter::ExecuteInformation().

void vtkImageAccumulate::ExecuteData | ( | vtkDataObject * | out | ) | `[protected]`

| Reimplemented from vtkImageToImageFilter.

## Member Data Documentation

float vtkImageAccumulate::ComponentSpacing[3]`[protected]`

| Definition at line 134 of file vtkImageAccumulate.h.

float vtkImageAccumulate::ComponentOrigin[3]`[protected]`

| Definition at line 135 of file vtkImageAccumulate.h.

int vtkImageAccumulate::ComponentExtent[6]`[protected]`

| Definition at line 136 of file vtkImageAccumulate.h.

double vtkImageAccumulate::Min[3]`[protected]`

| Definition at line 143 of file vtkImageAccumulate.h.

double vtkImageAccumulate::Max[3]`[protected]`

| Definition at line 144 of file vtkImageAccumulate.h.

double vtkImageAccumulate::Mean[3]`[protected]`

| Definition at line 145 of file vtkImageAccumulate.h.

double vtkImageAccumulate::StandardDeviation[3]`[protected]`

| Definition at line 146 of file vtkImageAccumulate.h.

long int vtkImageAccumulate::VoxelCount`[protected]`

| Definition at line 147 of file vtkImageAccumulate.h.

int vtkImageAccumulate::ReverseStencil`[protected]`

| Definition at line 149 of file vtkImageAccumulate.h.

The documentation for this class was generated from the following file:

- Imaging/vtkImageAccumulate.h